<template>
	<div class="personal">
		<!-- <el-contaier> -->
			<el-row >
				<el-col :span="24">
					
		<div class="personal-info">
			<el-row>
			<el-col :span="2"></el-col>
			<el-col :span="5">
			<el-image
				class="personal-img"
				fit="contain"
				src="https://p.qqan.com/up/2021-7/16272658317808058.jpg"
				@click="dialogTableVisible = true"
			/></el-col>
			<el-col :span="12">
			<div class="personal-msg">
				<div class="username">{{ personalInfo.username }}</div>
				<div class="introduction">{{ personalInfo.introduction }}</div>
			</div></el-col>
			<el-col :span="5">
			<el-button class="edit-info" round color="rgb(21, 185, 185,0.6)" dark="isDark" plain :icon="Edit" @click="goPage()"
				>修改个人信息</el-button
			></el-col></el-row>
		</div>
		<el-row class="www">
			<el-col :span="18">
		<div class="personal-body" >
			<song-list
				:songList="collectSongList"
				:show="true"
				@changeData="changeData"
				style="margin-top: 10px;"
			></song-list>
		</div>
	</el-col>
		</el-row>
		<el-dialog v-model="dialogTableVisible" title="修改头像">
			<upload></upload>
		</el-dialog>
	</el-col>
			</el-row>
	<!-- </el-contaier> -->
	</div>
</template>

<script lang="ts">
import { defineComponent, nextTick, ref, computed, watch, reactive } from "vue";
import { useStore } from "vuex";
import { Edit } from "@element-plus/icons-vue";
import SongList from "@/components/SongList.vue";
import Upload from "../setting/Upload.vue";
import mixin from "@/mixins/mixin";
import { HttpManager } from "@/api";
import { RouterName } from "@/enums";

export default defineComponent({
	components: {
		SongList,
		Upload,
	},
	setup() {
		const store = useStore();

		const { routerManager } = mixin();

		const dialogTableVisible = ref(false);
		const collectSongList = ref([]); // 收藏的歌曲
		const personalInfo = reactive({
			username: "",
			userSex: "",
			birth: "",
			location: "",
			introduction: "",
		});
		const userId = computed(() => store.getters.userId);
		const userPic = computed(() => store.getters.userPic);
		watch(userPic, () => {
			dialogTableVisible.value = false;
		});

		function goPage() {
			routerManager(RouterName.Setting, { path: RouterName.Setting });
		}
		async function getUserInfo(id) {
			const result = (await HttpManager.getUserOfId(id)) as ResponseBody;
			personalInfo.username = result.data[0].username;
			personalInfo.userSex = result.data[0].sex;
			personalInfo.birth = result.data[0].birth;
			personalInfo.introduction = result.data[0].introduction;
			personalInfo.location = result.data[0].location;
		}
		// 获取收藏的歌曲
		async function getCollection(userId) {
			collectSongList.value = [];
			const collectIDList = ref([]); // 存放收藏的歌曲ID
			const result = (await HttpManager.getCollectionOfUser(
				userId
			)) as ResponseBody;
			for (let i in result) {
				collectIDList.value.push(result[i].songId);
			}
			const results = (await HttpManager.getSongOfId(
				collectIDList.value.toString()
			)) as ResponseBody;
			for (let i in results.songs) {
				collectSongList.value.push(results.songs[i]);
			}
		}

		function changeData() {
			getCollection(userId.value);
		}

		nextTick(() => {
			getUserInfo(userId.value);
			getCollection(userId.value);
		});

		return {
			Edit,
			userPic,
			dialogTableVisible,
			collectSongList,
			personalInfo,
			attachImageUrl: HttpManager.attachImageUrl,
			goPage,
			changeData,
		};
	},
});
</script>

<style lang="scss" scoped>
@import "@/assets/css/var.scss";

.personal {
	// padding: ;
	padding-top: 80px;
	background-color: rgb(21, 185, 185,0.1);
	// padding-bottom: -100px;
	&::before {
		content: "";
		background-color: rgb(21, 185, 185,0.6);
		position: absolute;
		top: 0;
		width: 100%;
		height: $header-height + 200px;
	}
}

.personal-info {
	.personal-img{
		height: 200px;
		height: 200px;
		border: 5px solid rgb(223, 223, 223);
	}
	.edit-info{
		margin-top: 140px;
	}
}
// 	position: relative;
// 	margin-bottom: 60px;
// 	.personal-img {
// 		height: 200px;
// 		width: 200px;
// 		border-radius: 50%;
// 		border: 5px solid $color-white;
// 		position: absolute;
// 		top: -180px;
// 		left: 50px;
// 		cursor: pointer;
// 	}
// 	.personal-msg {
// 		margin-left: 300px;
// 		position: absolute;
// 		top: -120px;

// 		.username {
// 			font-size: 50px;
// 			font-weight: 600;
// 		}

// 		.introduction {
// 			font-size: 20px;
// 			font-weight: 500;
// 		}
// 	}
// 	.edit-info {
// 		position: absolute;
// 		right: 10vw;
// 		margin-top: -120px;
// 	}
// }
.personal-body{
	border: 1px rgb(157, 157, 157) solid;
	border-bottom:none ;
	margin-top: 50px;
	margin-left: 100px;
	padding: 10px 10px;
}
@media screen and (min-width: $sm) {
	.personal-body {
		padding: 0px 100px;
	}
}

@media screen and (max-width: $sm) {
	// .edit-info {
	// 	display: none;
	// }
	.personal-info {
		.personal-img {
			width: 110px;
			height: 110px;
		}
		.personal-msg {
			margin-left: 180px;
			.username {
				font-size: 25px;
				font-weight: 600;
			}
		}
		.edit-info {
			right: 70px;
			top: 40px;
		}
	}
}
</style>
